package com.ruoyi.oa.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.oa.domain.bo.OaInsuranceTemplateDetailBo;
import com.ruoyi.oa.domain.vo.OaInsuranceTemplateDetailVo;
import com.ruoyi.oa.domain.OaInsuranceTemplateDetail;
import com.ruoyi.oa.mapper.OaInsuranceTemplateDetailMapper;
import com.ruoyi.oa.service.IOaInsuranceTemplateDetailService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 社保/公积金模板明细Service业务层处理
 *
 * @author ruoyi
 * @date 2025-06-23
 */
@RequiredArgsConstructor
@Service
public class OaInsuranceTemplateDetailServiceImpl implements IOaInsuranceTemplateDetailService {

    private final OaInsuranceTemplateDetailMapper baseMapper;

    /**
     * 查询社保/公积金模板明细
     */
    @Override
    public OaInsuranceTemplateDetailVo queryById(Long insuranceDetailId){
        return baseMapper.selectVoById(insuranceDetailId);
    }

    /**
     * 查询社保/公积金模板明细列表
     */
    @Override
    public TableDataInfo<OaInsuranceTemplateDetailVo> queryPageList(OaInsuranceTemplateDetailBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OaInsuranceTemplateDetail> lqw = buildQueryWrapper(bo);
        Page<OaInsuranceTemplateDetailVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询社保/公积金模板明细列表
     */
    @Override
    public List<OaInsuranceTemplateDetailVo> queryList(OaInsuranceTemplateDetailBo bo) {
        LambdaQueryWrapper<OaInsuranceTemplateDetail> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OaInsuranceTemplateDetail> buildQueryWrapper(OaInsuranceTemplateDetailBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OaInsuranceTemplateDetail> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getInsuranceTemplateId() != null, OaInsuranceTemplateDetail::getInsuranceTemplateId, bo.getInsuranceTemplateId());
        lqw.eq(StringUtils.isNotBlank(bo.getInsuranceType()), OaInsuranceTemplateDetail::getInsuranceType, bo.getInsuranceType());
        lqw.eq(bo.getAmount() != null, OaInsuranceTemplateDetail::getAmount, bo.getAmount());
        return lqw;
    }

    /**
     * 新增社保/公积金模板明细
     */
    @Override
    public Boolean insertByBo(OaInsuranceTemplateDetailBo bo) {
        OaInsuranceTemplateDetail add = BeanUtil.toBean(bo, OaInsuranceTemplateDetail.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setInsuranceDetailId(add.getInsuranceDetailId());
        }
        return flag;
    }

    /**
     * 修改社保/公积金模板明细
     */
    @Override
    public Boolean updateByBo(OaInsuranceTemplateDetailBo bo) {
        OaInsuranceTemplateDetail update = BeanUtil.toBean(bo, OaInsuranceTemplateDetail.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OaInsuranceTemplateDetail entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除社保/公积金模板明细
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
